%define anolis_release 3

%bcond_without debug

%if %{with debug}
%global _find_debuginfo_dwz_opts %{nil}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

Name:           containernetworking-plugins
Version:        1.2.0
Release:        %{anolis_release}%{dist}
Summary:        Libraries for writing CNI plugin
License:        ASL 2.0
URL:            https://github.com/containernetworking/plugins
Source0:        https://github.com/containernetworking/plugins/archive/refs/tags/v%{version}.tar.gz
Patch1:  	0001-add-sw64-support.patch

BuildRequires: systemd-rpm-macros pkgconfig(libsystemd)
BuildRequires: golang >= 1.16.6 go-rpm-macros go-md2man

Requires: systemd

Obsoletes: containernetworking-cni < 0.7.1-2

Provides: containernetworking-cni = %{version}-%{release}
Provides: container-network-stack = 1
Provides: kubernetes-cni

%description
The Container Network Interface

CNI (Container Network Interface), a Cloud Native Computing Foundation project, consists of a specification 
and libraries for writing plugins to configure network interfaces in Linux and Windows containers, along 
with a number of supported plugins. CNI concerns itself only with network connectivity of containers and 
removing allocated resources when the container is deleted. Because of this focus, CNI has a wide range 
of support and the specification is simple to implement.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n plugins-%{version}
rm -rf plugins/main/windows
sed -i 's/\/opt\/cni\/bin/\%{_prefix}\/libexec\/cni/' plugins/ipam/dhcp/systemd/cni-dhcp.service

%build
export ORG_PATH="github.com/containernetworking"
export REPO_PATH="$ORG_PATH/plugins"

if [ ! -h gopath/src/${REPO_PATH} ]; then
        mkdir -p gopath/src/${ORG_PATH}
        ln -s ../../../.. gopath/src/${REPO_PATH} || exit 255
fi

export GOPATH=$(pwd)/gopath
mkdir -p $(pwd)/bin

export PLUGINS="plugins/main/* plugins/meta/* plugins/sample plugins/ipam/*"
for d in $PLUGINS; do
        if [ -d "$d" ]; then
                plugin="$(basename "$d")"
                %gobuild -o "${PWD}/bin/$plugin" "$@" "$REPO_PATH"/$d
        fi
done

%install
mkdir -p %{buildroot}%{_libexecdir}/cni/
install -p -m 0755 bin/* %{buildroot}/%{_libexecdir}/cni
mkdir -p %{buildroot}%{_unitdir}
for file in cni-dhcp.socket cni-dhcp.service; do
        install -p plugins/ipam/dhcp/systemd/$file %{buildroot}%{_unitdir}
done

%files
%license LICENSE
%dir %{_libexecdir}/cni
%{_libexecdir}/cni/*
%{_unitdir}/cni-dhcp.service
%{_unitdir}/cni-dhcp.socket

%files doc
%doc OWNERS.md README.md RELEASING.md CONTRIBUTING.md

%changelog 
* Tue Apr 01 2025 Dong Chuanjian <chuanjian@nfschina.com> - 1.2.0-3
- Add sw_64 support

* Tue Apr 11 2023 yuanhui <yuanhui@linux.alibaba.com> - 1.2.0-2
- Optimize the spec file

* Wed Mar 08 2023 yuanhui <yuanhui@linux.alibaba.com> - 1.2.0-1
- Update containernetworking-plugins to 1.2.0

* Wed Aug 31 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.1.1-1
* update containernetworking-plugins to 1.1.1

* Fri Mar 11 2022 Zhongling He <zhonglingh@linux.alibaba.com> 1.0.1-1.1
- Init package from upstream v1.0.1
